
/******************************************************************
  (C) Copyright 2001 by UNITED BYTES
   
  web:  http://www.unitedbytes.de
        http://www.unitedbytes.org
		http://www.unitedbytes.net
  mail: info@unitedbytes.de

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, 
  Boston, MA  02111-1307, USA.

  *****************************************************************

  Program:      ubNetwork
  File:         sources/cub_n_socket.h
  Author:       Tim C. Schroeder, modified by Andreas Loeffler
  Date:         Mon, 10.04.2001
  Version:      1.0
  Description:  Simple socket class

  -----------------------------------------------------------------

  Changes:		-
  Date:			-
  Description:	-

  *****************************************************************/

#ifndef __CUB_NETWORK_SOCKET_H__
#define __CUB_NETWORK_SOCKET_H__

#include <winsock.h>

class CUB_Socket  
{
	public:
						CUB_Socket();
						CUB_Socket(SOCKET iSocket);
		virtual		   ~CUB_Socket();

		bool			Bind		 (unsigned int iPort, bool bListen);
		int				Select		 (bool bRead, bool bWrite, int iTimeOut);
		bool			Connect		 (char szIPAddress[], unsigned int iPort);
		void			GetLastError (char szErrDescription[]);
		bool			GetRemoteIP  (char szIPAddress[]);
		bool		    GetLocalIP   (char szIPAddress[]);
		int				Send		 (char *cBuffer, long lBufLen);
		int				Receive		 (char *cBuffer, long lBufLen);
		bool			ResolveHost  (char *cIP, char *cResponseBuffer);
		bool			CanAccept	 ();
		bool			CanReceive   ();
		CUB_Socket	   *Accept		 (struct sockaddr *addr,  int *addrlen);
		bool			CloseSocket  ();
		bool			Peek         ();
		bool			ClearSocketBuffer ();
		bool			Wait         (long lNetworkEvents, DWORD dwTimeOut);
		void			ResolveHost  (char szHost[]);
		bool			SetSocketBlockingMode (bool bBlocking);
		
		SOCKET			m_sock;
		struct			sockaddr_in m_sa;
		bool			CreateSocket();

		bool			Init();
		static int		m_iInstCout;	 // Use this to prevent multiple initialisations of the WSA
};

#endif